/*

Um exemplo de como captar SENHAS via get/read e ecoar ASTERISTICOS na linha
de get.

Autor:
      toya
      14/maio/2002
      toya@ieg.com.br
      http://www.toya.hpg.com.br

Compilar:
      Clipper getsenha /N
Linkar
      Blinker fi getsenha
         ou
      Rtlink fi getsenha


*/      


func main()
clea

*            +------------- Tamanho da variavel em bytes
*            |   +--------- Senha vlida
*            |   |
if pegasenha(10,'AUTORIDADE')
   @ 20,10 say 'SENHA ok.'
else
   @ 20,10 say 'SENHA invalida'
endi

return NIL

* -----------------------------------------------------------------------------
func pegasenha(tamanho,senhaok)
* -----------------------------------------------------------------------------
local ok := .f.
@ 10,28 say '  Favor informar a SENHA  ' color 'gr+*/r' 

* DICA: Posicionar o cursor na linha,coluna do primeiro caracter da senha a ser
*      digitada
@ 12,30 say ''

xsenha = KEYINPUT(tamanho,.f.,.f.,'r/w')

return( uppe(xsenha)=uppe(senhaok) )

* -----------------------------------------------------------------------------
function keyinput()
* -----------------------------------------------------------------------------
param p_numchars,p_upcase,p_echochar,p_cor       
private f_str, f_i, f_key, f_c, f_mrow, f_mcol
p_numchars = iif (type ('p_numchars') = 'N', p_numchars, 80)
p_upcase = iif (type ('p_upcase') = 'L', p_upcase, .f.)
p_echochar = iif (type ('p_echochar') = 'L', p_echochar, .t.)
p_cor = iif (type ('p_cor') = 'C', p_cor,setcolor())
oldcor := setcolor()
f_str = ''
f_i = 1
setcolor(p_cor)
do while f_i <= p_numchars
   f_key = inkey (0)
   do case
      case f_key > 31 .and. f_key < 127
         f_c = iif (p_upcase, upper (chr (f_key)), chr (f_key))
         f_str = f_str + f_c
         f_i = f_i + 1
         ?? iif (p_echochar, f_c, '*')
      case f_key = 8 .and. f_i > 1
         f_mrow = iif (col () = 0, row () - 1, row ())
         f_mcol = iif (col () = 0, 79, col () - 1)
         @ f_mrow, f_mcol say ' ' 
         @ f_mrow, f_mcol say '' 
         f_i = f_i - 1
         f_str = iif (f_i = 1, '', substr (f_str, 1, f_i - 1))
      case f_key = 13
         exit
      case f_key = 27
         f_str = ''
         exit
   endcase
enddo
setcolor(oldcor)
return f_str
